package bonecoatirador;

import JPlay.Keyboard;
import JPlay.Sprite;
import JPlay.Window;

 /**
  * @author Gefersom Cardoso Lima
  * Federal Fluminense University - UFF - Brazil
  * Computer Science
  */  

public class Boneco extends Sprite
{
    //Usamos essa variável, pois quando o boneco pára de se locomover perdemos
    //qual era o lado para qual o mesmo estava se locomovendo.
    private int sentidoAnterior; // e - esquerda ; d - direita
    private int sentido;

    public Boneco()
    {
            super("boneco.png", 28);
            setTotalDuration(1960);
            sentido = Constantes.RIGHT;
            sentidoAnterior = Constantes.RIGHT;
            setFloor(500);
            setCurrFrame(17);
    }

    public void move(Keyboard teclado, Window janela)
    {

            //Retorna em qual sentido o boneco está se locomovendo,
            //se é para a esquerda ou para a direita.

            //Faz o boneco se locomover para a esquerda.            
            if ( teclado.keyDown(Keyboard.LEFT_KEY) && this.x > 1 )
            {
                    //Se antes o boneco se locomovia para a direita ou estava parado.
                    if (sentido != Constantes.LEFT) 
                    {   
                        setSequence(0, 13);
                        sentidoAnterior = Constantes.LEFT;
                        sentido = Constantes.LEFT;
                    }
                    this.x -= 2;

            }
            else
            {
                    //Faz o boneco se locomover para a direita.
                    if ( teclado.keyDown(Keyboard.RIGHT_KEY) && this.x + this.width < janela.getWidth() )
                        {
                                //Se antes o boneco se locomovia para a esquerda ou estava parado.
                                if (sentido != Constantes.RIGHT)
                                {
                                    setSequence(14, 27);
                                    sentidoAnterior = Constantes.RIGHT;
                                    sentido = Constantes.RIGHT;
                                }
                                this.x += 2;
                        }
                    else
                    {                     
                        //O boneco está parado.
                        sentido = Constantes.STOP;

                        //Verifica se o sentido anterior do boneco e seta o frame correspondente
                        //a esse sentido.
                        if (sentidoAnterior == Constantes.RIGHT)
                            setCurrFrame(17);
                        else
                        {
                            //Verifica se o sentido anterior do boneco e seta o frame correspondente
                            //a esse sentido.
                            if (sentidoAnterior == Constantes.LEFT)
                                setCurrFrame(3);
                        }
                    }
            }

            //Se o boneco não está parado então pode rodar a animação
            if (sentido != Constantes.STOP) update();
            
            jump();
    }

    public int getSentido()
    {
            return sentidoAnterior;
    }
}

