/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bonecoatirador;

import JPlay.Sound;
import JPlay.Window;
import java.util.LinkedList;

 /**
  * @author Gefersom Cardoso Lima
  * Federal Fluminense University - UFF - Brazil
  * Computer Science
  */  

public class ControladorTiros
{
    LinkedList<Tiro> objetos = new LinkedList<Tiro>();

    public void addTiro(double x, double y, int sentido, int floor)
    {
            Tiro tiro = new Tiro(x, y, sentido);
            tiro.setFloor(floor);

            //Adiciona o objeto no começo da lista.
            objetos.addFirst(tiro);
    }

    public void step(int floor, Window janela)
    {
            for(int i=0; i < objetos.size(); i++)
            {
                    Tiro tiro = objetos.removeFirst();
                    tiro.move(janela);
                    tiro.update();

                    //Se o tiro não tocou o chão ou a parede da esquerda ou
                    //a parede da direita, então, adiciona novamente a lista de tiros.
                    if ( tiro.isOnFloor() == false && tiro.x > 1 && tiro.x + tiro.width < 800)
                    {
                            tiro.fall();
                            objetos.addLast(tiro);
                    }
                    else
                    {
                            //O tiro não passou em alguns dos testes .
                            Sound explosao = new Sound("explosao.wav");
                            explosao.play();
                    }
            }
    }

    //Desenha os tiros na tela.
    public void draw()
    {
            for(int i=0; i < objetos.size(); i++)
            {
                    Tiro tiro = objetos.removeFirst();
                    tiro.draw();
                    objetos.addLast(tiro);
            }
    }
}
